package com.terraformersmc.terrestria.init.helpers;

import com.terraformersmc.terraform.entity.TerraformBoatEntity;
import com.terraformersmc.terraform.item.TerraformBoatItem;
import com.terraformersmc.terraform.util.RecipeUtil;
import com.terraformersmc.terrestria.Terrestria;
import java.util.function.Supplier;
import net.minecraft.class_1299;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_1822;
import net.minecraft.class_2248;
import net.minecraft.class_2378;
import net.minecraft.class_2960;

public class TerrestriaRegistry {

	public static class_1747 registerBlockItem(String name, class_2248 block) {
		class_1747 item = new class_1747(block, new class_1792.class_1793().method_7892(Terrestria.ITEM_GROUP));
		item.method_7713(class_1792.field_8003, item);

		RecipeUtil.registerCompostableBlock(block);

		return class_2378.method_10230(class_2378.field_11142, new class_2960(Terrestria.MOD_ID, name), item);
	}

	public static class_1822 registerSignItem(String name, class_2248 standing, class_2248 wall) {
		return class_2378.method_10230(class_2378.field_11142, new class_2960(Terrestria.MOD_ID, name), new class_1822(new class_1792.class_1793().method_7892(Terrestria.ITEM_GROUP), standing, wall));
	}

	public static TerraformBoatItem registerBoatItem(String name, Supplier<class_1299<TerraformBoatEntity>> boatType) {
		return class_2378.method_10230(class_2378.field_11142, new class_2960(Terrestria.MOD_ID, name), new TerraformBoatItem (
			(world, x, y, z) -> {
				TerraformBoatEntity entity = boatType.get().method_5883(world);

				entity.method_5814(x, y, z);

				return entity;
			},
			new class_1792.class_1793().method_7892(Terrestria.ITEM_GROUP).method_7889(1)
		));
	}

	public static <T extends class_2248> T register(String name, T block) {
		return class_2378.method_10230(class_2378.field_11146, new class_2960(Terrestria.MOD_ID, name), block);
	}
}
