package com.terraformersmc.terrestria.mixin;

import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3090;
import net.minecraft.class_3747;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_3090.class)
public class MixinMegaPineTreeFeature {
	@Inject(method = "prepareGroundColumn", at = @At("HEAD"))
	private void prepareGroundColumn(class_3747 world, class_2338 pos, CallbackInfo info) {
		for(int i = 2; i >= -3; --i) {
			class_2338 posUp = pos.method_10086(i);

			if (world.method_16358(posUp, (blockState_1) -> (blockState_1.method_11614() == TerrestriaBlocks.BASALT_DIRT) || (blockState_1.method_11614() == TerrestriaBlocks.BASALT_GRASS_BLOCK))) {
				world.method_8652(posUp, TerrestriaBlocks.BASALT_PODZOL.method_9564(), 18);
				break;
			}

			if (!world.method_16358(posUp, class_2680::method_11588) && i < 0) {
				break;
			}
		}
	}
}
