package com.terraformersmc.terrestria.mixin;

import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import net.minecraft.class_1308;
import net.minecraft.class_1345;
import net.minecraft.class_1928;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_1345.class)
public class MixinEatGrassGoal {
	@Shadow
	@Final
	private class_1308 mob;

	@Shadow
	@Final
	private class_1937 world;

	@Shadow
	private int timer;

	@Inject(method = "canStart", at = @At(value = "FIELD", target = "Lnet/minecraft/block/Blocks;GRASS_BLOCK:Lnet/minecraft/block/Block;"), cancellable = true)
	private void canStart(CallbackInfoReturnable<Boolean> callbackInfo) {
		class_2338 pos = new class_2338(this.mob);

		if(this.world.method_8320(pos.method_10074()).method_11614() == TerrestriaBlocks.BASALT_GRASS_BLOCK) {
			callbackInfo.setReturnValue(true);
		}
	}

	@Inject(method = "tick", at = @At("HEAD"))
	private void tick(CallbackInfo info) {
		if (this.timer - 1 == 4) {
			class_2338 pos = new class_2338(this.mob);
			class_2338 downPos = pos.method_10074();

			if (this.world.method_8320(downPos).method_11614() == TerrestriaBlocks.BASALT_GRASS_BLOCK) {
				if (this.world.method_8450().method_8355(class_1928.field_19388)) {
					this.world.method_20290(2001, downPos, class_2248.method_9507(class_2246.field_10219.method_9564()));
					this.world.method_8652(downPos, TerrestriaBlocks.BASALT_DIRT.method_9564(), 2);
				}

				this.mob.method_5983();
			}
		}
	}
}
