package com.terraformersmc.terrestria.mixin;

import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2404;
import net.minecraft.class_2680;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_2404.class)
public class MixinFluidBlock {
	@Inject(method = "receiveNeighborFluids", at = @At("RETURN"))
	public void formBasaltCobblestone(class_1937 world, class_2338 pos, class_2680 state, CallbackInfoReturnable<Boolean> callback) {
		// Either Cobblestone or Obsidian formed

		if(!callback.getReturnValueZ()) {
			class_2680 here = world.method_8320(pos);

			if(here.method_11614() != class_2246.field_10445) {
				// Obsidian was formed, nothing to override

				return;
			}

			class_2248 below = world.method_8320(pos.method_10074()).method_11614();
			class_2248 cobblestone = TerrestriaBlocks.BASALT.cobblestone.full;

			// If basalt cobblestone / stone is below, change to basalt cobblestone

			if(below == TerrestriaBlocks.BASALT.plain.full || below == cobblestone) {
				world.method_8501(pos, cobblestone.method_9564());
			}
		}
	}
}
